' More OpenGL Adventures

Framework BRL.BlitzGL
Import BRL.System
Import BRL.Basic
Import BRL.PNGLoader

Include "b3dloader.bmx" ' Cheesy but works, just about!

Global Verts#[65535]		' Vertex Array
Global Normals#[65535]		' Normal Array
Global texco#[65535]		' Texture Co-ordnate Array
Global ind[65535]			' Index Array
Global mx,my				' Mouse X & Y
Global FPS, RFPS,LastSEcs	' Frame Counter Stuff

bglCreateContext 1024,768,32,0,BGL_FULLSCREEN|BGL_BACKBUFFER|BGL_DEPTHBUFFER

bglSetSwapInterval 0

Global tex_name=bglTexFromPixmap( LoadPixmap( "trans.png" ) )

bglSetMouseVisible False

Local ax#,ay#

glShadeModel(GL_SMOOTH)

Global light_position#[] = [100.0, 100.0, 50.0, 0.0]   	' Spec's for the light
Global light_AMB#[] = [1.0,1.0,1.0,1.0]					' Uuuuugly
Global light_DIF#[] = [1.0,1.0,1.0,1.0]					' Nassssty

glLightfv(GL_LIGHT0, GL_POSITION, light_position)		' Horror
glLightfv(GL_LIGHT0, GL_AMBIENT, light_AMB)				' Shock
glLightfv(GL_LIGHT0, GL_DIFFUSE, light_DIF)				' Awrk!
glLightf(GL_LIGHT0, GL_CONSTANT_ATTENUATION, 1.5)
glLightf(GL_LIGHT0, GL_LINEAR_ATTENUATION, 0.5)
glLightf(GL_LIGHT0, GL_QUADRATIC_ATTENUATION, 0.2)

readb3d( "head.b3d" )									' Invoke the Cheesy(tm) B3DLoader

glEnableClientState (GL_VERTEX_ARRAY)					' Enable the Vertex Array
glEnableClientState (GL_NORMAL_ARRAY)					' Enable the Normal Array
glEnableClientState (GL_INDEX_ARRAY)					' Enable the Index Array
glEnableClientState (GL_TEXTURE_COORD_ARRAY)			' Enable the TexCoordinate Array

glVertexPointer(3, GL_FLOAT, 0, verts)					' Set the Pointer
glNormalPointer(GL_FLOAT, 0, normals)					' To where the Arrays
glIndexPointer (GL_INT, 0, IND)							' Live in System
glTexCoordPointer(2, GL_FLOAT,0, texco)					' Memory

glEnable(GL_TEXTURE_2D)
glBindTexture GL_TEXTURE_2D,tex_name
glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR)
glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR)

glCullFace GL_BACK
glEnable(GL_CULL_FACE)
glEnable(GL_LIGHTING)
glColor3f(1,1,1)
glClearDepth(1.0)
glEnable(GL_LIGHT0)
glEnable(GL_DEPTH_TEST)
glDepthFunc(GL_LEQUAL)	

glMatrixMode GL_PROJECTION
glLoadIdentity
gluPerspective 45,1024.0/768.0,0.1,1000

While Not KeyDown(KEY_ESCAPE)

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT)
	
	glMatrixMode GL_MODELVIEW
	glLoadIdentity

	glTranslatef 0,0,-4 '0'0
	glRotatef my,1,0,0
	glRotatef mx,0,1,0
	ax=ax+1
	ay=ay+2
	If KeyHit(KEY_W) Then 
		wire = wire + 1
		If wire = 3 Then wire = 0
	EndIf
	
	If KeyHit(KEY_C) Then 
		cull = cull ~ 1			' Where's my XOR gone then! :)
	EndIf
	
	If KeyHit(KEY_F) Then 
		flipmesh = flipmesh ~ 1			' Where's my XOR gone then! :)
	EndIf
	
	If flipmesh = 1 Then
	  glFrontFace GL_CCW
	Else
	  glFrontFace GL_CW
	EndIf

	If cull = 0 Then
	  glenable(GL_CULL_FACE)
	Else
	  gldisable(GL_CULL_FACE)
	EndIf
	
	If wire = 0 Then
	  glPolygonMode(GL_FRONT, GL_FILL)
	  glPolygonMode(GL_BACK, GL_FILL)
	EndIf
	If wire = 1 Then
	  glPolygonMode(GL_FRONT, GL_LINE)
	  glPolygonMode(GL_BACK, GL_LINE)
	EndIf
	If wire = 2 Then
	  glPolygonMode(GL_FRONT, GL_POINT)
	  glPolygonMode(GL_BACK, GL_POINT)
	EndIf
	
	glEnable(GL_DEPTH_TEST)
	glDrawElements(GL_TRIANGLES, ICT, GL_UNSIGNED_INT, IND);

	mx = MouseX()
	my = MouseY()
	
	bglDrawText "Blitzmax Inline OpenGL. "+rfps+" fps.",20,20
	bglDrawText (vind/3)+" Vertices.",20,40
	bglDrawText (ICT/3)+" Triangles.",20,60
	bglDrawText "W - Cycle (Solid / Wireframe / Points) ("+wire+")",20,80
	bglDrawText "C - Toggle Backface Culling ("+cull+")",20,100
	bglDrawText "F - Flip Mesh ("+flipmesh+")",20,120

	checkfps()
	
	bglSwapBuffers
	
	FlushMem

Wend

Function CheckFPS()
	If (MilliSecs()-lastsecs) <1000 Then 
		fps = fps +1
	Else
		lastsecs = MilliSecs()
	rfps = fps
		fps = 0
	EndIf
End Function
