Strict

Global DotParticlesList:TList = new TList
Global BoomList:TList = new TList
'Rocks
Global AsterList:TList = new TList
'shots
global ShotsList:TList = new TList

  Type Explosion
    field x#,y#,frame,size#,ftime
    Method Update()
      if ftime = 0
        frame:+1
        ftime = 2
      else
        ftime:-1
      endif
      if frame<40
        SetColor 255,255,255
		SetAlpha 1
        SetBlend LIGHTBLEND
        SetScale size,size
        SetRotation 0
        DrawImage boomimage,x,y,frame
      else
        BoomList.remove(self)
      endif
    EndMethod
    function Create:Explosion(x#,y#,s#)
      local e:Explosion = new Explosion
      e.x=x
      e.y=y
      e.size=s
      e.frame = 0
      e.ftime = 5
      return e
    EndFunction
  EndType


Function AddBoom(x#,y#,s#)
  BoomList.AddLast( Explosion.Create(x,y,s) )
EndFunction

Function UpdateBooms()
  local a:Explosion
  for a=eachin boomlist
    a.Update()
  next
EndFunction
''
  Type DotParticles
    field x#,y#,dx#,dy#,phase#=1,size#,spd#,rot

    Method Update()
      x=x + (dx * spd)
      y=y + (dy * spd)
      phase:-0.01
      if phase>0
        SetColor 255,255,255
        SetBlend ALPHABLEND
        SetAlpha phase
        SetScale size,size
        SetRotation rot
        rot:+10
        DrawRect x,y,size,size
      else
        DotParticlesList.remove(self)
      endif
    EndMethod
    function Create:DotParticles(x#,y#,s#)
      local e:DotParticles = new DotParticles
      local ang#=rand(0,359)
      e.x=x
      e.y=y

      e.dx=cos( ang )
      e.dy=sin( ang )
      e.spd=rand(3,15)
      e.size=s
      return e
    EndFunction
  EndType


Function AddDotParticles(x#,y#,s#,count)
  local a
  for a=0 until count
    DotParticlesList.AddLast( DotParticles.Create(x,y,s) )
  next
EndFunction

Function Updateparticles()
  local a:DotParticles 
  for a=eachin DotParticlesList
    a.Update()
  next
EndFunction


''
Type Entity
  field x#,y#
  field dx#,dy#,spd#
  field rotspd#,rot#

  Method Update() Abstract
  Method Draw() Abstract
EndType

Type Asteroid Extends Entity
  Field size#

  Method CheckCollisions()

  EndMethod

  Method Update()
    x = x +( dx * spd )
    y = y +( dy * spd )
    if x>GraphicsWidth()+256 x=-256
    if x<-256 x=GraphicsWidth()+256
    if y>GraphicsHeight()+256 y=-256
    if y<-256 y=GraphicsHeight()+256

    If CheckCollisions()
      size:/2.0
      if size<0.1
        AsterList.remove(self)
      endif
    endif
  EndMethod

  Method Draw()
    SetBlend MASKBLEND
    SetAlpha 1
    SetScale size,size
    SetRotation rot
    rot:+rotspd
    DrawImage AsterImage,x,y
  EndMethod

  Function Create:Asteroid(x#,y#,size#=0.5,dx#=0.3,dy#=0.7,spd#=2)
    local a:Asteroid = new Asteroid
    a.x=x
    a.y=y
    a.dx=dx
    a.dy=dy
    a.spd=spd
    a.size=size
    a.rot = 0
    a.rotspd = rnd(-1,1)
    return a
  EndFunction

EndType

Type PlShots Extends Entity
  field size#,life

  Method Draw()
    SetBlend LIGHTBLEND
    SetScale size,size
    SetAlpha 1
    SetRotation rot
    rot:+rotspd
    DrawImage playershot,x,y
  EndMethod
  Method Update()

    x = x +( dx * spd )
    y = y +( dy * spd )
    if x>GraphicsWidth()+32 x=-32
    if x<-32 x=GraphicsWidth()+32
    if y>GraphicsHeight()+32 y=-32
    if y<-32 y=GraphicsHeight()+32
    life:-1
    if life<1
      AddBoom x,y,0.65
      AddDotParticles x,y,1,100
      ShotsList.remove( self )
    endif
  EndMethod

  Function Create:PlShots(x#,y#,angle#)
    local a:PlShots = new PlShots
    a.x=x
    a.y=y
    a.dx=cos(angle)
    a.dy=sin(angle)
    a.spd=5
    a.size=0.20
    a.rot = 0
    a.rotspd = 14
    a.life = 80
    ShotsList.AddLast( a )
    return a
  EndFunction
EndType

Function SetHSVColor(_hue#,_sat#,_val#)
	Local	r#,g#,b#	
	If _sat<=0 
		r=_val*255;g=r;b=r
	Else
		Local h#=_hue/60
		Local i#=Floor( h )
		Local f#=h-i
		Local p#=_val*(1-_sat)
		Local q#=_val*(1-(_sat*f))
		Local t#=_val*(1-(_sat*(1-f)))
		Select Int(i)
			Case 0 r=_val;g=t;b=p
			Case 1 r=q;g=_val;b=p
			Case 2 r=p;g=_val;b=t
			Case 3 r=p;g=q;b=_val
			Case 4 r=t;g=p;b=_val
			Case 5 r=_val;g=p;b=q
		End Select
	EndIf
	SetColor 255*r,255*g,255*b
End Function

Graphics 640,480,32
HideMouse 'dont want the mouse just yet

'load in the media
Global backdrop:TImage = loadimage("media\back.png")
global asterimage:TImage = loadimage("media\asteroid.png")
MidHandleImage asterimage
global boomimage:TImage= loadanimimage("media\boomstrip.PNG",64,64,0,40)
MidHandleImage boomimage
global playerimage:TImage=loadimage("media\player-ship.PNG")
MidHandleImage playerimage
global playershot:TImage=loadimage("media\shot.png")
MidHandleImage playershot
global Shieldimg:TImage=loadimage("media\shield.png")
MidHandleImage Shieldimg

SetHandle 0.5,0.5



local tdx#,tdy#
local a=0
for a=0 until 14
  AsterList.AddLast( Asteroid.Create( rnd(-256,Graphicswidth()+256),..
                                     rnd(-256,Graphicsheight()+256),..
                                     (1+rnd(4))*0.2,..
                                     rnd(-1,1),..
                                     rnd(-1,1),..
                                     1+rnd(3) )  )
next

'players globals
Global playerX#=320, playerY#=240, playerAng#=0, player_scale#=0.4, Shieldstate=0
Global PlayerThrustdx#=0, PlayerThrustdy#=0, PlayerShield = 0

'Main Loop
while not keydown(KEY_ESCAPE)
  Updatedisplay()

  'DrawPlayer
  SetBlend MASKBLEND
  SetColor 255,255,255
  SetRotation playerAng
  SetAlpha 1
  SetScale player_scale#,player_scale#
  Drawimage playerimage,playerx,playerY

  'Control Player
  if keydown(KEY_LEFT) playerAng:-8
  if keydown(KEY_RIGHT) playerAng:+8
  'shields on
  if keydown(KEY_DOWN)
    PlayerShield = 1
    SetScale 0.55,0.55
    SetBlend LIGHTBLEND
	SetHSVColor Shieldstate,1,.5
    Shieldstate:+10
    if shieldstate>360 ShieldState=0
    SetRotation ShieldState+playerAng
    DrawImage Shieldimg,playerx,playerY
  else
    'can only fire with shields off
    PlayerShield = 0
    if keyHit(KEY_SPACE) PlShots.Create(playerx,playerY,playerAng-90)
  endif
  'thrusting
  if KeyDown(KEY_UP)
    tdx=cos( playerAng-90 ) * 0.1
    tdy=sin( playerAng-90 ) * 0.1

    PlayerThrustdx# = PlayerThrustdx# + tdx
    PlayerThrustdy# = PlayerThrustdy# + tdy

  Endif
  'Slow down the thrusting
  playerx:+PlayerThrustdx
  playerY:+PlayerThrustdy
  PlayerThrustdx#:*0.995
  PlayerThrustdy#:*0.995
  'bounds check
  if playerx>graphicswidth()+64 playerx=-64
  if playerx<-64 playerx=graphicswidth()+64
  if playery>graphicsheight()+64 playery=-64
  if playery<-64 playery=graphicsheight()+64
  FlushMem
  flip
wend
end

Function UpdateRocks()
  local a:Asteroid
  
  for a=eachin AsterList
    a.Update()
    if a
     a.Draw()
    endif
  next
EndFunction

Function UpdateShots()
  local a:PlShots
  
  for a=eachin ShotsList
    a.Update()
    if a
     a.Draw()
    endif
  next
EndFunction

Function UpdateDisplay()
  Cls
  SetRotation 0
  SetColor 255,255,255
  SetBlend SOLIDBLEND
  SetScale 1,1
  DrawImage backdrop,0,0

  UpdateRocks()
  UpdateShots()
  UpdateBooms()
  Updateparticles()
EndFunction
