strict
'
' Game Demo Coded By David Bird (Birdie)
'
incbin "media/sand.png"
incbin "media/ship1.png"
incbin "media/cloud.png"
incbin "media/shot.png"
incbin "media/shot2.PNG"
incbin "media/mud.png"
incbin "media/smoke.png"
incbin "media/scan.png"
incbin "media/zombie_0.png"
incbin "media/zombie_1.png"
incbin "media/zombie_2.PNG"
incbin "media/zombie_3.PNG"
incbin "media/zombie_4.PNG"
incbin "media/zombie_5.PNG"
incbin "media/zombie_6.png"
incbin "media/zombie_7.PNG"
incbin "media/Title.png"
incbin "media/HitSpace.png"

global C_ScreenWidth# = 640, C_ScreenHeight# = 480
global C_ScreenMidX# =C_ScreenWidth/2
global C_ScreenMidY# =C_ScreenHeight/2
Global MapPosition_X#=400, MapPosition_Y#=400
Global WorldSize = 8192
Global Scanner_Rot#
global Scanner_X#= C_ScreenWidth - 80
global Scanner_Y#= 80
global Scanner_Scale# = 0.5
global ObjectList:Tlist = new TList
Global DetailList:TList = New TList
global CloudList:TList  = New TList
Global ScanList:TList   = New TList

global TitleWidth#,TitleHeight#
graphics C_ScreenWidth, C_ScreenHeight ,32
HideMouse

'media globals
global media_sand:TImage
global media_ship1:TImage
global media_cloud:TImage
global media_shots:TImage
global media_shot2:TImage
global media_mud:TImage
global media_smoke:TImage
Global Media_scan:TImage
global media_Title:TImage
global media_HitSP:TImage

global Media_zombie:TImage[8]
LoadMedia()

Local P1:Player = new Player
ObjectList.AddLast p1

'title screen

while not keydown(KEY_SPACE)
  cls
  SetBlend SOLIDBLEND
  setcolor 255,255,255
  TileImage Media_sand,MapPosition_X,MapPosition_Y
  MapPosition_X:+1
  SetRotation 0
  SetBlend ALPHABLEND
  SetColor 255,255,255
  SetAlpha 1
  SetScale TitleWidth,TitleHeight
  DrawImage Media_Title,C_ScreenMidX,C_ScreenMidY-24
  setscale 1,1
  setAlpha 0.5
  drawimage media_HitSP, C_ScreenMidX, C_ScreenHeight - media_HitSP.height
  flip
  flushmem()
wend

local a
for a=0 until 300
  cloud.Create( rnd(-WorldSize,WorldSize), rnd(-WorldSize,WorldSize) )
next
for a=0 until 500
  Baddie.Create(rnd(-1000,1000), rnd(-1000,1000), 0)
next

while not keydown(KEY_ESCAPE)
  cls
  UpdateObjects()

  DrawLevel(p1)
  DrawObjects()
  DrawScanner( P1 )

  FlushMem()
  flip
wend
end

Function LoadMedia()
  SetHandle 0.5,0.5
  AutoMidHandle true
  media_sand  = loadimage("incbin::media/sand.png")
  media_ship1 = loadimage("incbin::media/ship1.png")
  media_cloud = loadimage("incbin::media/cloud.png")
  media_shots = loadimage("incbin::media/shot.png")
  media_shot2 = loadimage("incbin::media/shot2.PNG")
  media_scan  = loadimage("incbin::media/scan.png")
  media_mud   = loadimage("incbin::media/mud.png")
  media_smoke = loadimage("incbin::media/smoke.png")
  media_Title = loadimage("incbin::media/Title.png")
  media_HitSP = loadimage("incbin::media/HitSpace.png")
  
  'scale to fullscreen

  TitleWidth = media_title.width / C_ScreenWidth
  TitleHeight= media_title.height / (C_ScreenHeight+48)
  Media_zombie[0] = Loadanimimage("incbin::media/zombie_0.png",32,64,0,17)
  Media_zombie[1] = Loadanimimage("incbin::media/zombie_1.png",32,64,0,17)
  Media_zombie[2] = Loadanimimage("incbin::media/zombie_2.PNG",32,64,0,17)
  Media_zombie[3] = Loadanimimage("incbin::media/zombie_3.PNG",32,64,0,17)
  Media_zombie[4] = Loadanimimage("incbin::media/zombie_4.PNG",32,64,0,17)
  Media_zombie[5] = Loadanimimage("incbin::media/zombie_5.PNG",32,64,0,17)
  Media_zombie[6] = Loadanimimage("incbin::media/zombie_6.png",32,64,0,17)
  Media_zombie[7] = Loadanimimage("incbin::media/zombie_7.PNG",32,64,0,17)

EndFunction

Function DrawLevel(o:Entity)
  'using the object{o} position and direction to draw the map
'  MapPosition_X = MapPosition_X + ((o.x - MapPosition_X)*0.25)
'  MapPosition_Y = MapPosition_Y + ((o.y - MapPosition_Y)*0.25)
  MapPosition_X = o.x
  MapPosition_Y = o.y
  setblend SOLIDBLEND
  setcolor 255,255,255
  setscale 1,1
  TileImage Media_sand,MapPosition_X,MapPosition_Y

EndFunction

Function UpdateObjects()
  local e:Entity
  for e=EachIn ObjectList
    e.Update()
  next
EndFunction

Function DrawObjects()
  local e:Entity
  local c:Cloud
  for c=EachIn CloudList
    c.Update()
  next

  'Draw Shadows
  for e=EachIn ObjectList
    e.DrawShadow()
  next
  'Draw Details
  local d:Detail
  for d=eachin DetailList
    d.Update(MapPosition_X, MapPosition_Y)
  next


  'Draw objects without shadows
  for e=EachIn ObjectList
    e.DrawBody()
  next

  'DrawClouds

  for c=EachIn CloudList
    c.DrawShadow()
  next
  for c=EachIn CloudList
    c.DrawBody()
  next

EndFunction

type Entity
  field x#,y#
  field height#
  field rotation#
  field spd#=1

  Method Update() Abstract

  Method DrawBody() Abstract
  Method DrawShadow() Abstract
endtype

Type Player Extends Entity
  field RotationSpd#
  field liftSpd#
  field thrust#
  field osc#

  Method Update()
    if KeyDown(KEY_UP)
      thrust:+0.01
      if thrust>0.5
        thrust = 0.5
      endif
    endif
    if KeyDown(KEY_DOWN)
      thrust:-0.05
    endif
    spd:+thrust

    if thrust<0
      thrust = 0
    endif

    if spd>8
      spd=8
    endif
    if spd<0.5 spd = 0.5

    If keyHit(KEY_SPACE)
      local a,thei#
      thei = height +(3.5*cos(osc) )

      Shots.Create x, y, spd+5, thei, rotation
      for a=0 until 3
        Shots.Create x, y, spd+5, thei, rotation+rnd(-1.75,1.75)
      next
    endif
    local sz#=14*(1+(height/140.0))
    local sd#=16
    local cs#= cos(rotation-90)
    local sn#= sin(rotation-90)
    local ddx# = sz
    local ddy# = 9

    local tx1# = ddx*cs + ddy*sn
    local ty1# = ddx*sn - ddy*cs
    ddx=-ddx
    local tx2# = ddx*cs + ddy*sn
    local ty2# = ddx*sn - ddy*cs

    local thei#
    thei = height +(3.5*cos(osc) )
    local deltasm#= ( 0.5 * (spd/8.0))
    Trail.Create( x+tx1, y+ty1, thei, deltasm, rotation )
    Trail.Create( x+tx2, y+ty2, thei, deltasm, rotation )

    local tx#= 20 * cos(rotation)
    local ty#= 20 * sin(rotation)
    local rd= 255*thrust*2
    local gn= rd*0.7
    local bl= gn*0.5
    ColTrail.Create( x-tx, y-ty, thei, 0.3, rotation, [rd, gn, bl] ,2.0)

    ColTrail.Create( x-tx, y-ty, thei, 0.3, rotation, [rd*2, 0, 0] ,1.0)

    If KeyDown(KEY_RIGHT)
      rotationSpd:+0.25
      if rotationSpd>2
        rotationSpd=2
      endif
    endif
    If KeyDown(KEY_LEFT)
      rotationSpd:-0.25
      if rotationSpd<-2
        rotationSpd=-2
      endif
    endif
    rotation:+rotationSpd
    rotationSpd:*0.95

    If KeyDown(KEY_A)
      liftSpd:-0.02
      if liftSpd<-1
        liftSpd=-1
      endif
    endif
    If KeyDown(KEY_Z)
      liftSpd:+0.02
      if liftSpd>1
        liftSpd=1
      endif
    endif
    height:+liftSpd

    liftspd:*0.985

    if height<4
      height = 4
      liftspd = 0
    endif
    if height>50
      height = 50
      liftspd=0
    endif
    x=x+(spd*cos(rotation))
    y=y+(spd*sin(rotation))
    if x>WorldSize x=-WorldSize
    if x<-WorldSize x=WorldSize
    if y>WorldSize y=-WorldSize
    if y<-WorldSize y=WorldSize
    osc:+1
  EndMethod

  Method DrawShadow()
    local dx#,dy#,sz#,thei#
    thei = height +(3.5*cos(osc) )
    sz =(0.002*thei)
    setRotation rotation+90
    setblend ALPHABLEND
    setscale 0.25+sz,0.25+sz
    setcolor 0,0,0
    setalpha 0.5
    drawimage media_ship1,C_ScreenMidX + (x-MapPosition_X), C_ScreenMidY + ( y - MapPosition_Y )
  EndMethod

  Method DrawBody()
    local dx#,dy#,sz#,thei#
    thei = height +(3.5*cos(osc) )
    sz =(0.002*thei)
    setalpha 1
    setRotation rotation+90
    setblend MASKBLEND
    setcolor 255,255,255
    dx=thei/3.0
    dy=thei
    setscale 0.25+sz, 0.25+sz
    DrawImage media_ship1,(x-MapPosition_X+dx) + C_ScreenMidX,(y-MapPosition_Y+dy) + C_ScreenMidY
  EndMethod
  Function Create:Player(x#,y#)
    local p:Player = new Player
    p.x=x
    p.y=y
    p.height = 4
    p.spd=1
    ObjectList.AddFirst p
    return p
  EndFunction
EndType

type Cloud
  field x#,y#,height#, rotation

  Method Update()
    x:+1
    y:+0.1
    if x>WorldSize x=-WorldSize
    if x<-WorldSize x=WorldSize
    if y>WorldSize y=-WorldSize
    if y<-WorldSize y=WorldSize
  EndMethod

  Method DrawBody()
    local dx#,dy#
    dx=height/2.0
    dy=height
    setblend LIGHTBLEND
    setalpha 1
    SetScale 2.4,2.4
    SetRotation rotation
    SetColor 255,255,255
    DrawImage media_cloud,(MapPosition_X+dx-x) + C_ScreenMidX,(MapPosition_Y+dy-y) + C_ScreenMidY
  EndMethod

  Method DrawShadow()
    setblend ALPHABLEND
    setcolor 0,0,0
    SetAlpha 0.2
    SetScale 4, 4
    SetRotation rotation
    DrawImage media_cloud,(MapPosition_X-x) + C_ScreenMidX,(MapPosition_Y-y) + C_ScreenMidY
  EndMethod

  Function Create:Cloud( x#, y# )
    local c:Cloud = new Cloud
    c.x= x
    c.y= y
    c.rotation = rnd(360)
    c.height = 75
    CloudList.AddLast c
    return c
  EndFunction
EndType

Type Shots Extends Entity
  field life
  Method DrawBody()
    local dx#,dy#
    dx=height/3.0
    dy=height
    setblend MASKBLEND
    SetColor 255,255,255
    setalpha 1
    SetScale 1, 1
    SetRotation rotation + 90
    DrawImage media_shots,(MapPosition_X+dx-x) + C_ScreenMidX,(MapPosition_Y+dy-y) + C_ScreenMidY
  EndMethod

  Method DrawShadow()
    setblend ALPHABLEND
    setcolor 0,0,0
    SetAlpha 0.2
    SetScale 1, 1
    SetRotation rotation + 90
    DrawImage media_shots,(MapPosition_X-x) + C_ScreenMidX,(MapPosition_Y-y) + C_ScreenMidY
  EndMethod
  Method Update()
    x=x+(spd*cos(rotation))
    y=y+(spd*sin(rotation))
    if x>WorldSize x=-WorldSize
    if x<-WorldSize x=WorldSize
    if y>WorldSize y=-WorldSize
    if y<-WorldSize y=WorldSize
    if life<80
      height:-0.75
    endif
    Trail.Create( x, y, height, 0.3, rotation )
    if height<0
      ObjectList.Remove self
      Mud.Create(x, y, rotation)
      local ee#
      ee=1
      SmokeEmitter.create( x#,y#, 0,ee, ee, ee )
    else
      life:-1
      if life<0
        ObjectList.Remove self
      endif
    endif
  EndMethod

  Function Create:Shots(x#,y#,spd#,hei#,rot#)
    local s:Shots = new Shots
    s.x=x
    s.y=y
    s.rotation = rot
    s.spd = spd
    s.height = hei
    s.life = 100
    ObjectList.AddFirst s
    return s
  EndFunction
EndType

Type Detail
  field life
  field x#,y#,rot#,alp#
  field col[3]

  Method Update( wx#, wy# ) Abstract
EndType

Type Trail Extends Detail
  field height#
  field size#

  Method Update( wx#, wy# )
    local dx#, dy#
    alp:-0.005
    if alp<0
      life = 0
    endif

    life:-1
    if life<0
      DetailList.Remove self
    else
      dx=height/3.0
      dy=height
      setalpha alp
      setblend alphablend
      setrotation rot
      setcolor 255,255,255
      size:+0.05
      setscale 1,size
      drawrect (wx-x+dx)+C_ScreenMidX,(wy-y+dy)+C_ScreenMidY,10,1
    endif
  EndMethod

  Function Create:Trail(x#,y#,hei#,alp#,rot#)
    local t:Trail = new Trail
    t.x=x
    t.y=y
    t.height= hei
    t.alp = alp
    t.rot = rot
    t.life= 100
    t.size= 1
    DetailList.AddLast t
  EndFunction
endtype

Type ColTrail Extends Detail
  field height#,size#

  Method Update( wx#, wy# )
    local dx#, dy#
    alp:-0.01
    size:*0.9
    if alp<0
      life = 0
    endif

    life:-1
    if life<0
      DetailList.Remove self
    else
      dx=height/3.0
      dy=height
      setalpha alp
      setblend LIGHTBLEND
      setrotation rot
      setcolor Col[0],Col[1],Col[2]
      setscale size,size
      drawrect (wx-x+dx)+C_ScreenMidX,(wy-y+dy)+C_ScreenMidY,10,4
    endif
  EndMethod

  Function Create:ColTrail(x#,y#,hei#,alp#,rot#,col[],size#)
    local t:ColTrail = new ColTrail
    t.x=x
    t.y=y
    t.height= hei
    t.alp = alp
    t.rot = rot
    t.life= 100
    t.size=size
    t.col = col
    DetailList.AddLast t
  EndFunction
endtype

Type Mud Extends Detail

  Method Update( wx#, wy# )
    setrotation rot
    setblend ALPHABLEND
    if life<50
      alp = float(life)/100.0
    endif
    setalpha alp
    setcolor 0,0,0
    setscale 0.5,0.5

    drawimage media_mud,(wx-x)+C_ScreenMidX,(wy-y)+C_ScreenMidY
    life:-1
    if life<0
      DetailList.Remove self
    endif
  EndMethod

  Function Create:Mud(x#,y#, rot#)
    local m:Mud = new Mud
    m.x = x
    m.y = y
    m.rot = rot
    m.alp = 0.5
    m.life = 200
    DetailList.AddLast M
  EndFunction
EndType

type smoke_prt
  field x#,y#,height#  'local to emitter
  field scl#
  field alp#
  field dx#,dy#
  field life
  field rot#, rotdir#

  Method Draw( tx#, ty# )
    y:-dy
    x:+dx
    life:-1
    alp:-0.005
    scl:+0.017
    if alp<=0
      life =0
      return
    endif
    setblend LightBlend
    setalpha alp
    setscale scl,scl
    setrotation rot
    rot:+rotdir
    drawimage media_smoke, tx+x, ty+y
  EndMethod

  Function Create:smoke_prt(scl#,alp#,x#,y#,dx#,dy#,life)
    local s:Smoke_prt = new Smoke_prt
    s.x=x
    s.y=y
    s.dx=dx
    s.dy=dy
    s.life=life
    s.alp=alp
    s.scl=scl
    s.rotdir = rnd(-4,4)
    s.rot = rnd(360)
    return s
  EndFunction
endtype

type SmokeEmitter Extends Detail
  field smlist:TList = New TList

  field rd#,gn#,bl#, max_cnt=50, cur_cnt

  Method Update( wx#, wy# )
    local sp:smoke_prt
    SetColor 255*rd,255*gn,255*bl
    for sp=eachin smlist
      sp.Draw((wx-x)+C_ScreenMidX, (wy-y)+C_ScreenMidY)
      if sp.life<0
        'remove it and add another
        smlist.remove sp
        cur_cnt:-1
      endif
    next
    if cur_cnt<max_cnt
      smlist.addfirst( smoke_prt.Create( 0.2, 0.3, 0, 0, rnd( -0.1, 0.1 ), rnd(0.1,1), 40 ) )
      cur_cnt:+1
    endif
    life:-1
    if life<0
      DetailList.Remove self
      smlist.clear()
    endif
  EndMethod

  Function Create:SmokeEmitter(x#,y#, rot#,cr#,cg#,cb#)
    local sm:SmokeEmitter = new SmokeEmitter
    sm.x = x
    sm.y = y
    sm.rot = rot
    sm.alp = 0.20
    sm.life = 50
    sm.rd=cr
    sm.gn=cg
    sm.bl=cb

    DetailList.AddLast sm
  EndFunction
EndType

Type Baddie extends Entity
  field frame = 0
  field frm_p = 2
  field frm_t = 0
  field direct= 0
  field life

  method Update()
    frm_t:+1
    if frm_t>frm_p
      frm_t= 0
      frame:+1
      if frame = 17 frame = 0
    endif
    x=x+(spd*cos(rotation-90))
    y=y+(spd*sin(rotation-90))
    if x>WorldSize x=-WorldSize
    if x<-WorldSize x=WorldSize
    if y>WorldSize y=-WorldSize
    if y<-WorldSize y=WorldSize

    spd=0.3
    rotation:+1
    if rotation<0 rotation:+360
    if rotation>=360 rotation:-360
    direct = rotation / 45
  endmethod
  method DrawShadow()
    local dx = -12
    local dy = -4
    setblend alphaBlend
    setcolor 0,0,0
    setalpha 0.3
    setrotation -30
    setscale 0.43,0.47
    drawimage Media_zombie[direct],(MapPosition_X-x) + C_ScreenMidX+dx,(MapPosition_Y-y) + C_ScreenMidY+dy, frame

  endmethod
  method DrawBody()
    setblend alphaBlend
    setcolor 255,255,255
    setalpha 1
    setrotation 0
    setscale 0.4,0.4
    drawimage Media_zombie[direct],(MapPosition_X-x) + C_ScreenMidX,(MapPosition_Y-y) + C_ScreenMidY, frame

  endmethod

  Function Create:Baddie(x#,y#,spd#)
    local s:Baddie = new Baddie
    s.x=x
    s.y=y
    s.rotation = rand(350)
    s.spd = rnd(1,2)
    s.height = 0
    s.life = 100
    ObjectList.AddFirst s
    return s
  EndFunction

EndType

type Scan_Object
  field alp#,x#,y#,typ
  Method Update(cx#, cy#)
    alp:-0.01
    if alp<0
      ScanList.Remove self
    else
      setalpha alp
      drawrect cx+x,cy+y,5,5
    endif
  EndMethod
  Function Create:Scan_Object(x#, y#, typ )
    local so:Scan_Object = new Scan_Object
    so.x=x
    so.y=y
    so.typ=typ
    so.alp=0.4
    ScanList.AddLast so
  EndFunction
EndType

Function DrawScanner(p:Player) 'according to a certain player
  setblend LightBlend
  setcolor 255,255,255
  setalpha 0.5
  setrotation Scanner_Rot+90
  Scanner_rot:-5
  if scanner_rot<0 scanner_rot:+360

  SetScale Scanner_Scale,Scanner_Scale
  drawImage media_scan,Scanner_X,Scanner_Y
  local b:Baddie
  local so:Scan_Object
  local dx#,dy#,ang#,ln#

  for b=EachIn ObjectList
    'get angle to object
    dx=p.x-b.x
    dy=p.y-b.y
    ln=sqr(dx*dx+dy*dy)
    if ln<1200
      ang = atan2(dx,dy)
      if ang<0 ang=360+ang
      if abs(ang-(Scanner_rot))<2
        'add a new dot on the scanner
        Scan_Object.Create(dx/20.0, dy/20.0, 0 )
      endif
    endif
  next
  setblend LightBlend
  setalpha 0.25
  setcolor 48,64,48
  setrotation 0
  drawrect Scanner_X,Scanner_Y,256,256
  setcolor 0,255,0
  for so=eachin ScanList
    so.Update(scanner_x,Scanner_Y)
  next
EndFunction


