'
'Texture Packer
'Written By David Bird (Birdie)
'
Strict

Const PackerSize=128
Global TextureList:TextureContainer = TextureContainer.Create()

Type TextureContainer
	Field packTree:TexTree[10]
	Field packTree_Count=0
	Field PackTree_Alloc=10

	Method AddPackTree()
		If PackTree_Count>=PackTree_Alloc
			PackTree_Alloc:+2
			packTree= PackTree[..PackTree_Alloc]
		EndIf
		PackTree[PackTree_Count]=TexTree.Create( PackerSize, PackerSize )
		PackTree_Count:+1
		Return PackTree_Count-1
	EndMethod

	Method InsertTexture:TexNode( width, height )
		Local t:TexTree, n:TexNode
		Local a
		For a=0 Until PackTree_Count
			n = PackTree[a].InsertTexture( width, height )
			If n Return n
		Next
		'maybe check if widths are goosed
		a = AddPackTree()
		Return PackTree[a].InsertTexture( width, height )
	EndMethod
	Method Dump()
		Local a,x,y=16,ly
		For a=0 Until PackTree_Count
			SetOrigin x,y
			x:+packtree[a].width
			If x>=GraphicsWidth()
				x=0	
				y:+ly
			EndIf
			packtree[a].root.draw()
			ly=packtree[a].height
    	Next
		SetOrigin 0,0
	EndMethod
	Function Create:TextureContainer()
		Local t:TextureContainer = New TextureContainer
		Return t
	EndFunction
EndType

Function InsertTexture(width,height)
	TextureList.InsertTexture( width, height )
EndFunction

Type TexTree
	Field root:TexNode
	Field width#,height#

	Method InsertTexture:TexNode( w, h )
		Local n:TexNode = Insert( root, w, h )
		If n
			n.Used = True
			n.tree = Self
			Return n
		Else
			Return Null
		EndIf
	EndMethod

	Method Insert:TexNode(n:TexNode, w, h)
		Local newNode:TexNode
		Local dw, dh
		Local isleaf=False

		If Not n.l And Not n.r isleaf=True

		If IsLeaf=False
			newNode = Insert( n.l, w, h )
			If newNode Return newNode
			Return Insert( n.r, w, h )
		Else
			If n.Used
				Return Null
			EndIf
	   	EndIf
    	If w>n.w | h>n.h Return Null
		If w=n.w & h=n.h Then Return n
		dw = n.w - w
		dh = n.h - h
		If dw > dh Then
			n.l=TexNode.Create( n.x, n.y, w, n.h )
			n.r=TexNode.Create( n.x+w, n.y, n.w-w, n.h )
    	Else
			n.l=TexNode.Create( n.x, n.y, n.w, h )
			n.r=TexNode.Create( n.x, n.y+h, n.w, n.h-h )
		EndIf
		Return Insert( n.l, w, h )
	EndMethod

	Function Create:TexTree( width, height )
		Local t:TexTree = New TexTree
		t.width = width
		t.height = height

		t.root = TexNode.Create(0, 0, width, height )
		Return t
	EndFunction
EndType

Type TexNode
	Field l:TexNode,r:TexNode
	Field x#,y#,w#,h#
	Field used
	Field tree:TexTree
	Field cr#,cg#,cb#

	Method Draw()
		If used
			SetColor cr,cg,cb
			DrawRect x,y,w,h    'tempory debug an image can be here instead
		EndIf
		If l l.Draw()
		If r r.Draw()
	EndMethod

	Function Create:TexNode(x#,y#,w#,h#)
		Local n:TexNode = New TexNode
		n.x=x
		n.y=y
		n.w=w
		n.h=h
		n.cr=Rand(255)
		n.cg=Rand(255)
		n.cb=Rand(255)
		Return n
	EndFunction

EndType

Graphics 1024,768
Local a,cnt
While Not KeyDown(KEY_ESCAPE)
	Cls
	For a=0 Until 20
		InsertTexture( Rnd( 1, 32 ), Rnd( 1, 32 ) )
	Next
	cnt:+20
	TextureList.Dump()
	FlushMem
	SetColor 255,255,255
	DrawText "image count:"+Cnt,0,0
	Flip
Wend
