rem

A quick benchmark, by FlameDuck / Binary Therapy

end rem

strict

Graphics 1024,768

HideMouse

incbin "bmax160.png"
global myLogo:TImage = LoadImage( "incbin::bmax160.png" )
midhandleImage myLogo
Const XIMAGES = 7
Const YIMAGES = 7

type TblurImage
	field xpos:int, ypos:int
	field life:int=2^16
	field rots:double = 0
	field myList:TblurEffect

	function createBlurImage:TblurImage(x:int,y:int,arots:double)
		local temp:TblurImage = new TblurImage
		temp.xpos=x;temp.ypos=y;temp.rots=arots
		return temp
	end function

	method setList(aList:TblurEffect)
		myList = aList
	end method

	method update()
		life:/ 2
		if life <= 1
			myList.removeListItem( self )
		end if
	end method

	method draw()
		setAlpha life / 2^16!

		setrotation - rots
		local myx# = xpos * cos( rots ) - ypos * sin( rots ) + GraphicsWidth()/2
		local myy# = ypos * cos( rots ) + xpos * sin( rots ) + GraphicsHeight()/2

		drawImage myLogo,myx,myy
		SetAlpha 1
	end method

end type

type TblurEffect extends TList

	Field counter:int

	method doeffect()
		Local temp:TblurImage

		setBlend ALPHABLEND

		For temp = EachIn self
			temp.draw
			temp.update
		next
	end method

	method AddListItem(temp:Object)
		counter:+1
		self.addlast(temp)
	end method

	method removeListItem(temp:TblurImage)
			counter:-1
			self.remove(temp)
	end method
end type

type tSpawnPoint
	Field xpos:double,ypos:double
end type

type Tspawns
	Field points:TSpawnpoint[XIMAGES,YIMAGES]
	Field srots:double = 0

	function createSpawn:Tspawns()
		local temp:Tspawns = new Tspawns
		local xd:double = Graphicswidth()/XIMAGES
		local xo:double = Graphicswidth()/2

		Local i,n

		for i = 0 to XIMAGES-1
			for n = 0 to YIMAGES-1
				temp.points[i,n] = new tSpawnPoint
				temp.points[i,n].xpos = i*xd - xo + myLogo.width/2 +xo/(2*XIMAGES)
				temp.points[i,n].ypos = n*xd - xo + myLogo.height/2 + xo/(2*YIMAGES)
			next
		next

		return temp
	end function

	method rotate(angl:double)
		srots:+angl
		if srots < 0
			srots:+ 360
		else if srots > 360
			srots:-360
		end if
	end method

	method SpawnImages(alist:TblurEffect)
		Local i,n
		for i = 0 to XIMAGES-1
			for n = 0 to YIMAGES-1
				local newImage:TblurImage = TblurImage.createBlurImage(points[i,n].xpos,points[i,n].ypos,srots)
				newImage.setList(aList)
				aList.addListItem newImage
			next
		next
	end method

end type

local myList:TblurEffect = new TblurEffect
local mySpawns:Tspawns = Tspawns.CreateSpawn()
local intro:double = 0
local term:double = 0

While term < 1

	cls

	mySpawns.SpawnImages(myList)
	mySpawns.rotate(2)
	myList.doeffect

	DrawText "Featuring "+myList.counter+" real time rotated (x2) images",100,100

	setBlend ALPHABLEND
	setRotation 0
	setAlpha 1-intro+term
	setColor 0,0,0
	drawRect 0,0,1024,768
	setAlpha 1
	setColor 255,255,255

	if intro <= 1
		intro:+ .02
	end if

	if keyHit(KEY_ESCAPE) or term > 0
		term :+ .02
	end if

	flip
	flushMem

Wend

ShowMouse
