
'Simple demo of pixmap based paint program
'
'Use 'M' key to reposition magnify window, 'A' and 'Z' to zoom
'
Strict

Local file$="nature.png"

Const WIDTH#=640,HEIGHT#=480

Graphics WIDTH,HEIGHT,32

Local pic:TPixmap=LoadPixmap( file )
pic=ConvertPixmap( pic,PF_RGBA8888 )
pic=ResizePixmap( pic,pic.width*HEIGHT/pic.height,HEIGHT )

DrawPixmap pic,0,0

Const READY=0
Const SEL_MAG=1
Const DRAW_FREE=2
Const DRAW_LINE=3

Global mode=READY

Global zoom#=3

Global mag_ox,mag_oy,mag_visible=True
Global mag_x=WIDTH/2,mag_y=0,mag_width=WIDTH/2,mag_height=HEIGHT/2
Global mag_image:TImage

Local mx,my,px,py,dx,dy,ox,oy,md1,md2,mag_mouse,cnt

While Not KeyHit( KEY_ESCAPE )

	SetAlpha 1
	SetColor 255,255,255
	SetBlend SOLIDBLEND
	DrawPixmap pic,0,0
	
	If KeyHit( KEY_A )
		zoom:*1.25
		If zoom>32 zoom=32
	Else If KeyHit( KEY_Z )
		zoom:/1.25
		If zoom<1 zoom=1
	EndIf
	
	Local tx=MouseX()
	Local ty=MouseY()
	
	If MouseDown(1)
		If mag_visible And mag_mouse
			tx=(tx-mag_x)/zoom+mag_ox
			ty=(ty-mag_y)/zoom+mag_oy
		EndIf
		If tx<0 tx=0 Else If tx>=pic.width tx=pic.width-1
		If ty<0 ty=0 Else If ty>=pic.height ty=pic.height-1
		If Not md1
			ox=tx
			oy=ty
			md1=True
		EndIf
	Else
		If Not md1
			mag_mouse=tx>=mag_x And tx<mag_x+mag_width And ty>=mag_y And ty<mag_y+mag_height
		EndIf
		md1=False
		If mag_visible And mag_mouse
			tx=(tx-mag_x)/zoom+mag_ox
			ty=(ty-mag_y)/zoom+mag_oy
		EndIf
		If tx<0 tx=0 Else If tx>=pic.width tx=pic.width-1
		If ty<0 ty=0 Else If ty>=pic.height ty=pic.height-1
	EndIf
	
	px=mx
	py=my
	mx=tx
	my=ty
	dx=mx-px
	dy=my-py
	
	Select mode
	Case READY
		If KeyHit( KEY_M )
			mag_ox=mx
			mag_oy=my
			mode=SEL_MAG
		Else If md1
			mode=DRAW_FREE
		EndIf
	Case SEL_MAG
		mag_ox=mx
		mag_oy=my
		If md1
			mode=DRAW_FREE
		EndIf
	Case DRAW_LINE
		DrawRect mx,my,1,1
		DrawLine ox,oy,mx,my
		If Not md1
			Local x=Min(ox,mx),y=Min(oy,my)
			Local w=Max(ox,mx)-x+1,h=Max(oy,my)-y+1
			pic.Paste GrabPixmap( x,y,w,h ),x,y
			mode=READY
		EndIf
	Case DRAW_FREE
		DrawRect mx,my,1,1
		DrawLine px,py,mx,my
		Local x=Min(px,mx),y=Min(py,my)
		Local w=Max(px,mx)-x+1,h=Max(py,my)-y+1
		pic.Paste GrabPixmap( x,y,w,h ),x,y
		If Not md1
			mode=READY
		EndIf
	End Select
	
	If mag_visible
		Local x=mag_ox,y=mag_oy
		Local w=mag_width/zoom,h=mag_height/zoom
		Local pixmap:TPixmap=GrabPixmap( x,y,w,h )
		Local magimage:TImage=LoadImage( pixmap,0 )
		If mode=SEL_MAG
			SetBlend LIGHTBLEND
			SetColor 64,64,64
			DrawRect x,y,w,h
			SetColor 255,255,255
			SetBlend SOLIDBLEND
		EndIf
		SetScale zoom,zoom
		DrawImage magimage,mag_x,mag_y
		SetScale 1,1
	EndIf
	
	FlushMem

	Flip
	
Wend
