'Strict
'Module RichardBetson.RadialBlur
'ModuleInfo "Writen by Richard R Betson"
'ModuleInfo "Copyright (c) 2004 Richard R Betson"
'ModuleInfo "www.redeyeware.50megs.com - Email: Vidiot@gtgoin.net"
'ModuleInfo "Free for Public use. No Restrictions"


'Import BRL.System


Global RadialList:TList = New TList

Global w#
Global h#


Type RadialBlurInit 
	Field img_x
	Field img_y
	Field db_h#
	Field db_w#
	Field offset_x#
	Field offset_y#
	Field wscale#
	Field hscale#
	Field Ascale1#
	Field Ascale2#
	Field leaf
	Field blur_img
	Field rblur_handle
	Field width#
	Field height#


End Type 



Type RadialBlur Extends RadialBlurInit

	Method CreateRBlur:RadialBlur(bimg, x, y, width#, height#, leaf, db_width#, db_height#)

		ScaleToPixel(width,height,db_width,db_height)

		Part : RadialBlur=New RadialBlur
		part. leaf= leaf
		part. img_x= x+(width/2)
		part. img_y= y+(height/2)
		part. width#=width
		part. height#=height
		part. db_w= db_width
		part. db_h= db_height
		part. offset_x= ( ( width/2 )/leaf ) 
		part. offset_y= ( (height/2 )/leaf )
		part. wscale#= ( w#/Float(leaf))

		part. hscale#= (h#/Float(leaf))
		part. Ascale1#= (.85/Float(leaf))
		part. Ascale2#= 0	'Reserved for future use
		part. blur_img= bimg
		part. rblur_handle=part
		radiallist.AddLast part 
		
		Return part
	End Method

	Method FreeRBlur(obj_handle)
		RadialList.Remove(obj_handle)
	End Method 


	Method ResizeRBlur(obj_handle,x,y,width#, height#)
		

		Local part:RadialBlurInit
		For part=EachIn RadialList
		
			If part. rblur_handle=obj_handle

				ScaleToPixel(width,height,part.db_w,part.db_h)

				part. img_x= x+(width/2)
				part. img_y= y+(height/2)
				part. width#= width#
				part. height#= height#
				part. offset_x= ( ( width/2 )/part.leaf ) 
				part. offset_y= ( (height/2 )/part.leaf )
				part. wscale#= ( w#/Float(part.leaf))
				part. hscale#= (h#/Float(part.leaf))
				part. Ascale1#= (.85/(part.leaf))
				Exit
			EndIf
		Next

	End Method 


	Method PositionRBlur(obj_handle,x, y)

		Local part:RadialBlurInit
		For part=EachIn RadialList
		
			If part. rblur_handle=obj_handle

				part. img_x= x+(part.width/2)
				part. img_y= y+(part.height/2)
				Exit

			EndIf
		Next
	End Method


	Method update()
		
		GrabImage(blur_img,img_x-(db_w*.5),img_y-(db_h*.5)) 

		For i=1 To leaf
			SetScale ((i*wscale#)),(i*hscale#) 		
			SetAlpha(1.15- ((i*ascale1#)))
			DrawImage blur_img ,(img_x) - ( i*offset_x ), (img_y) - (i*offset_y)

		Next
		SetScale (1,1)
	End Method

	Method UpdateRblur()
		Local pt:RadialBlur
		For pt=EachIn RadialList
	      	pt.Update ()
		Next
	End Method


End Type 


Global rb:radialblur=New radialblur


Function CreateRadialBlur(bimg, x, y, width#, height#, leaf, db_width#, db_height#)
	tmp=rb . CreateRBlur(bimg, x, y, width#, height#, leaf, db_width#, db_height#)
	Return tmp
End Function


Function ResizeRadialBlur(obj_handle,x,y,width#, height#)
	rb . ResizeRBlur(obj_handle,x,y,width#, height#)
End Function 


Function PositionRadialBlur(obj_handle,x, y)
	rb . PositionRBlur(obj_handle,x, y)
End Function


Function FreeRadialBlur(obj_handle)
	rb . FreeRBlur(obj_handle)
End Function


Function UpdateRadialBlur()
	rb . UpdateRblur()
End Function 


Function ScaleToPixel(rect_w,rect_h,source_w,source_h)

	w#=( Float(rect_w)/Float(source_w) )
	h#=( Float(rect_h)/Float(source_h) )

End Function

